﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography.X509Certificates;
using System.Net.Sockets;
using System.Net;
using MySSLLib;
using System.Security.Cryptography;

namespace MySSLClient
{
  public class SslClient
  {
    private Socket client = null;
    private int port = 443;
    public X509Certificate2 localCertificate;
    private StateObject so;

    public void Start(X509Certificate2 cert, string ip)
    {
      localCertificate = cert;
      client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

      client.Connect(IPAddress.Parse(ip), port);

      so = new StateObject();
      so.workSocket = client;
      so.localCert = cert;
      DESCryptoServiceProvider des = new DESCryptoServiceProvider();
      so.localSessionKey = des.Key;
      SslHelper.PrintSessionKey(des.Key);

      SslHelper.Send(so, PackageType.Cert);
      client.BeginReceive(so.buffer, 0, StateObject.BUFFER_SIZE, SocketFlags.None, new AsyncCallback(OnDataReceived), so);
    }

    private void OnDataReceived(IAsyncResult ar)
    {
      StateObject so = (StateObject)ar.AsyncState;
      Socket clientSocket = so.workSocket;
      int read = clientSocket.EndReceive(ar);
      if (read > 0)
      {
        PackageType type = SslHelper.Handle(so, read);
        if (type == PackageType.Cert)
        {
          SslHelper.Send(so, PackageType.SessionKey);
        }
        else if (type == PackageType.SessionKey)
        {
          //SslHelper.Send(so, 0x03);
        }
      }
      clientSocket.BeginReceive(so.buffer, 0, StateObject.BUFFER_SIZE, SocketFlags.None, new AsyncCallback(OnDataReceived), so);

    }
  }
}
