﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.IO;
using System.Security.Cryptography.X509Certificates;
using System.Security.Cryptography;
using MySSLLib;

namespace MySSLServer
{


  public class SslServer
  {
    private Socket server = null;
    private int port = 443;
    public X509Certificate2 localCertificate;
    private StateObject so;

    public void Start(X509Certificate2 cert)
    {
      localCertificate = cert;
      server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
      server.Bind(new IPEndPoint(IPAddress.Any, port));
      server.Listen(5);
      server.BeginAccept(new AsyncCallback(OnClientConnected), server);
    }

    private void OnClientConnected(IAsyncResult ar)
    {
      Socket serverSocket = ar.AsyncState as Socket;
      Socket clientSocket = serverSocket.EndAccept(ar);
      serverSocket.BeginAccept(new AsyncCallback(OnClientConnected), null);

      so = new StateObject();
      so.workSocket = clientSocket;
      so.localCert = localCertificate;
      DESCryptoServiceProvider des = new DESCryptoServiceProvider();
      so.localSessionKey = des.Key;
      SslHelper.PrintSessionKey(des.Key);

      clientSocket.BeginReceive(so.buffer, 0, StateObject.BUFFER_SIZE, SocketFlags.None, new AsyncCallback(OnDataReceived), so);
    }

    private void OnDataReceived(IAsyncResult ar)
    {
      StateObject so = (StateObject) ar.AsyncState;
      Socket clientSocket = so.workSocket;
      int read = clientSocket.EndReceive(ar);
      if(read > 0)
      {
        PackageType type = SslHelper.Handle(so, read);
        if (type == PackageType.Cert)
        {
          SslHelper.Send(so, PackageType.SessionKey);
          SslHelper.Send(so, PackageType.Cert);
        }
        else if (type == PackageType.SessionKey)
        {
          //SslHelper.Send(so, 0x03);
        }
      }
      clientSocket.BeginReceive(so.buffer, 0, StateObject.BUFFER_SIZE, SocketFlags.None, new AsyncCallback(OnDataReceived), so);

    }
  }
}
